Bug 1323134 - glibc: stdio race condition causes crash during process shutdown
Summary: glibc: stdio race condition causes crash during process shutdown
Keywords:
Status: CLOSED WONTFIX
Alias: None
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: glibc
Version: 6.8
Hardware: Unspecified
OS: Unspecified
low
low
Target Milestone: rc
: ---
Assignee: glibc team
QA Contact: qe-baseos-tools-bugs
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2016-04-01 11:09 UTC by Florian Weimer
Modified: 2020-12-11 12:08 UTC (History)
7 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-08-15 19:07:16 UTC
Target Upstream Version:


Attachments (Terms of Use)
tst-stdio-exit-lock.c (1.76 KB, text/plain)
2016-04-01 11:09 UTC, Florian Weimer
no flags Details


Links
System ID Private Priority Status Summary Last Updated
Red Hat Bugzilla 1275384 0 unspecified CLOSED Segmentation violation can occur within glibc if fork() is used in a multi-threaded application 2021-02-22 00:41:40 UTC
Red Hat Bugzilla 1322544 0 unspecified CLOSED Segmentation violation can occur within glibc if fork() is used in a multi-threaded application 2021-02-22 00:41:40 UTC

Internal Links: 1275384 1322544

Description Florian Weimer 2016-04-01 11:09:24 UTC
Created attachment 1142511 [details]
tst-stdio-exit-lock.c

The test case for this upstream bug:

  http://sourceware.org/bugzilla/show_bug.cgi?id=12847

exercises a different code path as well, and crashes occasionally even if swbz#12847 is fixed.

This was corrected in this upstream commit, which is currently missing in Red Hat Enterprise Linux 6:

commit f22e10748fbabbf07161eb7a5540b8c0e18553c4
Author: Ulrich Drepper <drepper@gmail.com>
Date:   Fri Sep 9 16:15:25 2011 -0400

    Don't lock string streams in stream cleanup code

The attached test case triggers this bug about 80% of the time on my test VM.  It has to be run in a shell script, like this:

set -e
for x in `seq 1 100` ; do
  ./tst-stdio-exit-lock
done

Comment 2 Chris Dickens 2016-04-01 16:56:03 UTC
Hi,

This bug is not relevant to my use case as described in bug 1275384.

Thanks.


Note You need to log in before you can comment on or make changes to this bug.